"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __knownSymbol = (name, symbol) => {
  if (symbol = Symbol[name])
    return symbol;
  throw Error("Symbol." + name + " is not defined");
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
var __forAwait = (obj, it, method) => (it = obj[__knownSymbol("asyncIterator")]) ? it.call(obj) : (obj = obj[__knownSymbol("iterator")](), it = {}, method = (key, fn) => (fn = obj[key]) && (it[key] = (arg) => new Promise((yes, no, done) => (arg = fn.call(obj, arg), done = arg.done, Promise.resolve(arg.value).then((value) => yes({ value, done }), no)))), method("next"), method("return"), it);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  DocumentOcr: () => DocumentOcr
});
module.exports = __toCommonJS(src_exports);
var import_openai = __toESM(require("openai"));
var import_pdf_to_img = require("pdf-to-img");

// src/cropImage.ts
var { createCanvas, loadImage } = require("@napi-rs/canvas");
var sizeOf = require("buffer-image-size");
function cropImage(image) {
  return __async(this, null, function* () {
    const { width, height } = sizeOf(image);
    const img = yield loadImage(image);
    const canvas = createCanvas(width, height);
    const context = canvas.getContext("2d");
    context.drawImage(img, 0, 0);
    const data = context.getImageData(0, 0, width, height).data;
    const top = scanY(true);
    const bottom = scanY(false);
    const left = scanX(true);
    const right = scanX(false);
    if (top === null || bottom === null || left === null || right === null) {
      console.error("image is empty");
      return canvas.toDataURL();
    }
    const new_width = right - left;
    const new_height = bottom - top;
    canvas.width = new_width;
    canvas.height = new_height;
    context.drawImage(
      img,
      left,
      top,
      new_width,
      new_height,
      0,
      0,
      new_width,
      new_height
    );
    return canvas.toDataURL();
    function getRGB(x, y) {
      return {
        red: data[(width * y + x) * 4],
        green: data[(width * y + x) * 4 + 1],
        blue: data[(width * y + x) * 4 + 2]
      };
    }
    function isColor(rgb) {
      return rgb.red == 255 && rgb.green == 255 && rgb.blue == 255;
    }
    function scanY(top2) {
      var offset = top2 ? 1 : -1;
      for (var y = top2 ? 0 : height - 1; top2 ? y < height : y > -1; y += offset) {
        for (var x = 0; x < width; x++) {
          if (!isColor(getRGB(x, y))) {
            return y;
          }
        }
      }
      return null;
    }
    function scanX(left2) {
      const offset = left2 ? 1 : -1;
      for (let x = left2 ? 0 : width - 1; left2 ? x < width : x > -1; x += offset) {
        for (let y = 0; y < height; y++) {
          if (!isColor(getRGB(x, y))) {
            return x;
          }
        }
      }
      return null;
    }
  });
}

// src/index.ts
var dJSON = require("dirty-json");
var DocumentOcr = class {
  constructor({
    apiKey = process.env.OPENAI_API_KEY,
    model = "gpt-4-vision-preview",
    standardFontDataUrl = "https://unpkg.com/pdfjs-dist@3.5.141/standard_fonts/"
  }) {
    this.process = (_0) => __async(this, [_0], function* ({
      document,
      mimeType,
      prompt
    }) {
      var _a;
      if (typeof document === "string" && document.indexOf(",") > 0) {
        document = document.split(",")[1];
      }
      const buffer = Buffer.isBuffer(document) ? document : Buffer.from(document, "base64");
      const imageData = [];
      if (mimeType === "application/pdf") {
        try {
          const pdfPages = yield (0, import_pdf_to_img.pdf)(buffer, {
            scale: 2,
            docInitParams: {
              disableFontFace: true,
              standardFontDataUrl: this.standardFontDataUrl
            }
          });
          try {
            for (var iter = __forAwait(pdfPages), more, temp, error; more = !(temp = yield iter.next()).done; more = false) {
              const page = temp.value;
              imageData.push(page);
            }
          } catch (temp) {
            error = [temp];
          } finally {
            try {
              more && (temp = iter.return) && (yield temp.call(iter));
            } finally {
              if (error)
                throw error[0];
            }
          }
        } catch (e) {
          console.error(e);
        }
      } else {
        imageData.push(buffer);
      }
      const imageGPTArray = yield Promise.all(
        imageData.map((image) => __async(this, null, function* () {
          const message = {
            type: "image_url",
            image_url: {
              url: yield cropImage(image)
            }
          };
          return message;
        }))
      );
      const response = yield this.openai.chat.completions.create({
        model: this.model,
        // response_format: {
        //   type: 'json_object',
        // },
        max_tokens: 4096,
        temperature: 0,
        messages: [
          {
            role: "system",
            content: "in the images supplied find" + prompt + "\nRespond with a valid JSON object with all numbers as a string an no additional text or characters."
          },
          {
            role: "user",
            content: [...imageGPTArray]
          }
        ]
      });
      let content = (_a = response.choices[0].message.content) != null ? _a : "";
      content = content.replace("```json", "");
      content = content.replace("```", "");
      content = content.replace(/(?:\r\n|\r|\n)/g, "");
      content = content.replace(/(^,)|(,$)/g, "");
      return dJSON.parse(content != null ? content : "{}");
    });
    if (!apiKey) {
      throw new Error("OCR API Key is not defined");
    }
    this.apiKey = apiKey;
    this.model = model;
    this.standardFontDataUrl = standardFontDataUrl;
    this.openai = new import_openai.default({
      apiKey
    });
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DocumentOcr
});
//# sourceMappingURL=index.js.map